package controler;

import model.BoatModel;
import view.HeadingView;
import view.HeadingButtonView;

public class HeadingControler {
	
	//declaration d'une vue. On passe par la classe parente pour adresser une vue non dépendante de Swing.
	private HeadingView headingView=null;
	//declaration du modèle
	private BoatModel model=null;
	
	public HeadingControler(BoatModel model){
		this.model=model;
		//construction de la Vue(Controleur, Cap)
		headingView=new HeadingButtonView(this, model.getHeading());
		addListenersToModel();
	}
	
	private void addListenersToModel(){
		//Ajout de la vue à la liste des objets ecoutants (listeners) dans le modèle
		model.addHeadingListener(headingView);
	}
	
	public void displayViews(){
		headingView.display();
	}
	public void closeView(){
		headingView.close();
	}
	
	public void notifyHeadingChanged(int heading){
		//Reaction aux événement de l'utilisateur : içi, quant on recoit une valeur de cap de la Vue, on modifie la valeur dans le modèle
		model.setHeading(heading);
	}
	
}
