package model;

import java.util.EventObject;

//Evènement envoyé par le Modèle aux vues enregistrées pour qu'elle puisse mettre à jour la valeur du cap.
//Un HeadingChangedEvent contient juste la valeur du cap à mettre a jour dans la vue.
public class HeadingChangedEvent extends EventObject{

	private static final long serialVersionUID = 1L;
	private int newHeading;
	
	public HeadingChangedEvent(Object source,int newHeading){
		//La source est l'instance de BoatModel (ce n'est pas utilisé dans notre cas)
		super(source);
		//et on initialise la valeur interne du cap 
		this.newHeading=newHeading;
	}
	
	//methode appelée par la vue pour reccuperer la nouvelle valeur du cap
	public int getNewHeading(){
		return newHeading;
	}

}
