 package view;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;

import controler.HeadingControler;
import model.HeadingChangedEvent;

//classe concrète, interface graphique de gestion du cap
public class HeadingButtonView extends HeadingView{
	
	//fenetre
	private JFrame frame=null;
	//contenu de la fenetre
	private JPanel contentPane=null;
	//bouton "+"
	private JButton plus=null;
	//Bouton "-"
	private JButton minus=null;
	//valeur du cap pour la Vue
	private int heading;
	
	
	
	public HeadingButtonView(HeadingControler controler) {
		this(controler, 0);
	}
	public HeadingButtonView(HeadingControler controler, int heading){
		//enregistrement du controleur par la classe parente
		super(controler);
		//initialisation du cap
		this.heading=heading;
		//construction de l'interface
		buildFrame();
	}
	
	//construction de l'interface graphique
	//Cf cours Java
	private void buildFrame(){
		frame=new JFrame();
		frame.setResizable(false);
		contentPane=new JPanel();
		contentPane.setBorder(BorderFactory.createTitledBorder("Heading"));

		plus=new JButton("+");
		plus.addActionListener(new PlusActionListener());
		minus=new JButton("-");
		minus.addActionListener(new MinusActionListener());
		
		contentPane.add(plus);
		contentPane.add(minus);
		
		frame.setContentPane(contentPane);
		frame.setTitle("Heading setup");
		frame.pack();
	}
	
	public void close() {frame.dispose();}

	// C'est au controleur de dire quant la fenetre doit etre affichée
	public void display() {frame.setVisible(true);}
	
	//methode definie dans l'interface HeadingListener.
	//elle est appelée par le modèle dès que la valeur du cap change dans le modèle
	public void headingChanged(HeadingChangedEvent event) {
		//on se contente de mettre à jour la valeur locale du cap.
		heading=new Integer(event.getNewHeading());
	}
	
	//reaction aux évènements sur les boutons (actions utilisateur)
	//Cf cours Java
	class MinusActionListener implements ActionListener{
		public void actionPerformed(ActionEvent arg0) {
			//On envoie au controleur la nouvelle valeur du cap, pour qu'il mette à jour le modèle.
			getControler().notifyHeadingChanged(heading-10);
		}
	}
	
	class PlusActionListener implements ActionListener{
		public void actionPerformed(ActionEvent arg0) {
			getControler().notifyHeadingChanged(heading+10);
		}
	}
}
