package view;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.geom.GeneralPath;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.BevelBorder;

import controler.MixedInputControler;
import model.HeadingChangedEvent;
import model.SpeedChangedEvent;

public class MixedInputUIView extends MixedInputView{

	private JFrame frame=null;
	private JPanel controlPanel=null;
	private JButton plus=null;
	private JButton minus=null;
	private ModalJPanel contentTop=null;
	private int heading,speed;
	
	
	
	public MixedInputUIView(MixedInputControler controler) {
		this(controler, 0, 0);
	}
	public MixedInputUIView(MixedInputControler controler, int heading, int speed){
		super(controler);
		this.heading=heading;
		this.speed=speed;
		buildFrame();
	}
	
	private void buildFrame(){
		frame=new JFrame();
		frame.setResizable(false);
		
		//boite des boutons +/-
		plus=new JButton("+");
		plus.addActionListener(new PlusActionListener());
		minus=new JButton("-");
		minus.addActionListener(new MinusActionListener());
		
		//1
		//2
		//2
		
		//boite modale pour l'affichage des labels
		//3
		//4
		
		//panel de fond
		JPanel contentPane=new JPanel();
		contentPane.setLayout(new BoxLayout(contentPane,BoxLayout.Y_AXIS));
		//5
		//5
		
		//fenetre
		frame.setContentPane(contentPane);
		frame.setTitle("Boat Speed/heading setup");
		frame.pack();
	}
	
	
	public void close() {frame.dispose();}
	public void display() {frame.setVisible(true);}

	public void headingChanged(HeadingChangedEvent event) {
		heading=new Integer(event.getNewHeading());
		//15
	}
	public void speedChanged(SpeedChangedEvent event) {
		speed=new Integer(event.getNewSpeed());
		//15
	}
	
	class MinusActionListener implements ActionListener{
		public void actionPerformed(ActionEvent arg0){
			if(contentTop.isLeftSelected()){
				getControler().notifyHeadingSpeedChanged(heading-10,speed);
			}else{
				getControler().notifyHeadingSpeedChanged(heading,speed-1);
			}
		}
	}
	
	class PlusActionListener implements ActionListener{
		public void actionPerformed(ActionEvent arg0) {
			//13
			//13
			//13
			//13
			//13
		}
	}
	
	class ModalJPanel extends JPanel implements MouseListener{

		private static final long serialVersionUID = 1L;
		private JPanel arrow;
		private ModalJLabel l1,l2;
		
		public ModalJPanel(String s1, String s2){
			super();
			l1=new ModalJLabel(s1);
			l2=new ModalJLabel(s2);
			l2.setSelected(false);
			l1.setSelected(true);
			
			arrow=new JPanel(){
				public void paintComponent(Graphics g){
					Graphics2D g2d = (Graphics2D)g;
					g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
					
					//8
					//8
					
					//9
					//9
					//9
					
					//10
					//10
					//10
					//10
					//10
				}
			};
			arrow.setOpaque(false);
			arrow.setPreferredSize(new Dimension(50,100));
			
			setLayout(new BoxLayout(this,BoxLayout.LINE_AXIS));
			add(l1);
			add(arrow);
			add(l2);
		}
		public void switchButton(){
			//12
			//12
			//12
		}
		
		public boolean isLeftSelected(){
			return l1.isSelected();
		}
		public boolean isRightSelected(){
			return !isLeftSelected();
		}
		
		//11
		//11
		
		public void mouseClicked(MouseEvent arg0) {
			//14
		}
		public void mouseEntered(MouseEvent arg0) {}
		public void mouseExited(MouseEvent arg0) {}
		public void mousePressed(MouseEvent arg0) {}
		public void mouseReleased(MouseEvent arg0) {}
	}
	
	class ModalJLabel extends JPanel{
		private static final long serialVersionUID = 1L;
		//utilité du boolean selected ?
		//7
		//7
		private boolean selected=false;
		JLabel text;
		
		public ModalJLabel(String str){
			super();
			text=new JLabel(str);
			text.setHorizontalAlignment(JLabel.CENTER);
			text.setVerticalAlignment(JLabel.CENTER);
			text.setPreferredSize(new Dimension(100,100));
			add(text);
			setSelected(true);
		}
		public void setText(String str){
			text.setText(str);
		}

		public void setSelected(boolean selected){
			//fonctionnement : 
			//6
			//6
			if(selected){	setBorder(BorderFactory.createLineBorder(Color.GREEN,2));		}
			else{			setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));	}
			this.selected=selected;
		}
		public boolean isSelected(){return selected;}
	}
}
