package model;

import javax.swing.event.EventListenerList;

public class BoatModel {
	private int heading;
	private int speed;
	
	private EventListenerList speedListeners;
	private EventListenerList headingListeners;
	
	public BoatModel(){
		this(0,0);
	}
	
	public BoatModel(int heading,int speed){
		speedListeners=new EventListenerList();
		headingListeners=new EventListenerList();
		setHeading(heading);
		setSpeed(speed);
	}
	
	public int getSpeed(){return speed;}
	public void setSpeed(int speed){
		if(speed>25){
			this.speed=25;
		}else if(speed<0){
			this.speed=0;
		}else{
			this.speed=speed;
		}
		fireSpeedChanged();
	}
	public int getHeading(){return heading;}
	public void setHeading(int heading){
		if(heading<0){
			this.heading=360+heading;
		}else if(heading>=360){
			this.heading=heading-360;
		}else{
			this.heading=heading;
		}
		fireHeadingChanged();
	}
	
	public void addHeadingListener(HeadingListener listener){
		headingListeners.add(HeadingListener.class, listener);
	}
	public void removeHeadingListener(HeadingListener listener){
		headingListeners.remove(HeadingListener.class, listener);
	}
	public void addSpeedListener(SpeedListener listener){
		speedListeners.add(SpeedListener.class, listener);
	}
	public void removeHeadingListener(SpeedListener listener){
		speedListeners.remove(SpeedListener.class, listener);
	}
	
	private void fireHeadingChanged(){
		HeadingListener[] listenerList=(HeadingListener[])headingListeners.getListeners(HeadingListener.class);
		for(HeadingListener listener : listenerList){
			listener.headingChanged(new HeadingChangedEvent(this,getHeading()));
		}
	}
	private void fireSpeedChanged(){
		SpeedListener[] listenerList=(SpeedListener[])speedListeners.getListeners(SpeedListener.class);
		for(SpeedListener listener : listenerList){
			listener.speedChanged(new SpeedChangedEvent(this,getSpeed()));
		}
	}

}
