package view;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import controler.HeadingControler;
import model.HeadingChangedEvent;

public class HeadingButtonView extends HeadingView{

	private JFrame frame=null;
	private JPanel contentPane=null;
	private JButton plus=null;
	private JButton minus=null;
	private JLabel headingDisplay=null;
	private int heading;
	
	
	
	public HeadingButtonView(HeadingControler controler) {
		this(controler, 0);
	}
	public HeadingButtonView(HeadingControler controler, int heading){
		super(controler);
		this.heading=heading;
		buildFrame();
	}
	
	private void buildFrame(){
		frame=new JFrame();
		frame.setResizable(false);
		contentPane=new JPanel();
		contentPane.setLayout(new BorderLayout());
		contentPane.setBorder(BorderFactory.createTitledBorder("Heading"));

		plus=new JButton("+");
		plus.addActionListener(new PlusActionListener());
		minus=new JButton("-");
		minus.addActionListener(new MinusActionListener());
		
		headingDisplay=new JLabel("<html><H1>"+heading+"&deg</H1></html>",JLabel.CENTER);
		
		contentPane.add(headingDisplay,BorderLayout.NORTH);
		contentPane.add(plus,BorderLayout.LINE_START);
		contentPane.add(minus,BorderLayout.LINE_END);
		
		frame.setContentPane(contentPane);
		frame.setTitle("Heading setup");
		frame.pack();
	}
	
	
	public void close() {frame.dispose();}

	public void display() {frame.setVisible(true);}

	public void headingChanged(HeadingChangedEvent event) {
		heading=new Integer(event.getNewHeading());
		headingDisplay.setText("<html><H1>"+heading+"&deg</H1></html>");
	}
	
	class MinusActionListener implements ActionListener{
		public void actionPerformed(ActionEvent arg0) {
			getControler().notifyHeadingChanged(heading-10);
		}
	}
	
	class PlusActionListener implements ActionListener{
		public void actionPerformed(ActionEvent arg0) {
			getControler().notifyHeadingChanged(heading+10);
		}
	}
}
