package view;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import controler.SpeedControler;
import model.SpeedChangedEvent;

public class SpeedButtonView extends SpeedView{

	private JFrame frame=null;
	private JPanel contentPane=null;
	private JButton plus=null;
	private JButton minus=null;
	private JLabel speedDisplay=null;
	private int speed;
	
	
	
	public SpeedButtonView(SpeedControler controler) {
		this(controler, 0);
	}
	public SpeedButtonView(SpeedControler controler, int speed){
		super(controler);
		this.speed=speed;
		buildFrame();
	}
	
	private void buildFrame(){
		frame=new JFrame();
		frame.setResizable(false);
		contentPane=new JPanel();
		contentPane.setLayout(new BorderLayout());
		contentPane.setBorder(BorderFactory.createTitledBorder("Speed"));
		

		plus=new JButton("+");
		plus.addActionListener(new PlusActionListener());
		minus=new JButton("-");
		minus.addActionListener(new MinusActionListener());
		
		speedDisplay=new JLabel("<html><H1>"+speed+"nd</H1></html>",JLabel.CENTER);
		
		contentPane.add(speedDisplay,BorderLayout.NORTH);
		contentPane.add(plus,BorderLayout.LINE_START);
		contentPane.add(minus,BorderLayout.CENTER);
		
		frame.setContentPane(contentPane);
		frame.setTitle("Speed setup");
		frame.pack();
	}
	
	
	public void close() {frame.dispose();}

	public void display() {frame.setVisible(true);}

	public void speedChanged(SpeedChangedEvent event) {
		speed=new Integer(event.getNewSpeed());
		speedDisplay.setText("<html><H1>"+speed+"nd</H1></html>");
	}
	
	class MinusActionListener implements ActionListener{
		public void actionPerformed(ActionEvent arg0) {
			getControler().notifySpeedChanged(speed-1);
		}
	}
	
	class PlusActionListener implements ActionListener{
		public void actionPerformed(ActionEvent arg0) {
			getControler().notifySpeedChanged(speed+1);
		}
	}

}
